type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type comparison =
  | Eq
  | Lt
  | Gt

(** val compOpp : comparison -> comparison **)

let compOpp = function
  | Eq -> Eq
  | Lt -> Gt
  | Gt -> Lt

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type sumbool =
  | Left
  | Right

type 'a sumor =
  | Inleft of 'a
  | Inright

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type positive =
  | XI of positive
  | XO of positive
  | XH

(** val pcompare : positive -> positive -> comparison -> comparison **)

let rec pcompare x y r =
  match x with
    | XI x' ->
        (match y with
           | XI y' -> pcompare x' y' r
           | XO y' -> pcompare x' y' Gt
           | XH -> Gt)
    | XO x' ->
        (match y with
           | XI y' -> pcompare x' y' Lt
           | XO y' -> pcompare x' y' r
           | XH -> Gt)
    | XH -> (match y with
               | XI y' -> Lt
               | XO y' -> Lt
               | XH -> r)

type z =
  | Z0
  | Zpos of positive
  | Zneg of positive

(** val zcompare : z -> z -> comparison **)

let zcompare x y =
  match x with
    | Z0 -> (match y with
               | Z0 -> Eq
               | Zpos y' -> Lt
               | Zneg y' -> Gt)
    | Zpos x' ->
        (match y with
           | Z0 -> Gt
           | Zpos y' -> pcompare x' y' Eq
           | Zneg y' -> Gt)
    | Zneg x' ->
        (match y with
           | Z0 -> Lt
           | Zpos y' -> Lt
           | Zneg y' -> compOpp (pcompare x' y' Eq))

(** val dcompare_inf : comparison -> sumbool sumor **)

let dcompare_inf = function
  | Eq -> Inleft Left
  | Lt -> Inleft Right
  | Gt -> Inright

(** val zcompare_rec : z -> z -> (__ -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) ->
                       'a1 **)

let zcompare_rec x y h1 h2 h3 =
  match dcompare_inf (zcompare x y) with
    | Inleft x0 -> (match x0 with
                      | Left -> h1 __
                      | Right -> h2 __)
    | Inright -> h3 __

(** val z_le_dec : z -> z -> sumbool **)

let z_le_dec x y =
  zcompare_rec x y (fun _ -> Left) (fun _ -> Left) (fun _ -> Right)

(** val z_le_gt_dec : z -> z -> sumbool **)

let z_le_gt_dec x y =
  z_le_dec x y

(** val aux : z -> z list -> z list **)

let rec aux z0 = function
  | Nil -> Cons (z0, Nil)
  | Cons (a, l') ->
      (match z_le_gt_dec z0 a with
         | Left -> Cons (z0, (Cons (a, l')))
         | Right -> Cons (a, (aux z0 l')))

(** val sort : z list -> z list **)

let rec sort = function
  | Nil -> Nil
  | Cons (a, l0) -> aux a (sort l0)

